ALen equ $2d
BLen equ $2e
CLen equ $2f
APtr equ $30
BPtr equ $32
CPtr equ $34

TimerBValue equ $59
TimerB equ $c810

dseg
SoundProc_: public SoundProc_
    defw 0

    freq defw 0


; void InitSound();
cseg
InitSound_: public InitSound_
    psha
        clr SoundProc_
        clr SoundProc_+1
        ldaa #135
        staa $C811
    pula
rts


; void CallSound();
cseg
CallSound_: public CallSound_
    ldx SoundProc_
    if ne
        jsr 0,x
        clr SoundProc_
        clr SoundProc_+1
    endif
rts


; void Sound_Fire();
cseg
Sound_Fire_: public Sound_Fire_
    psha | pshb
        ldx #100
        stx freq
        do 
            jsr $f036
            ldx #1000
            do 
                dex
            while ne | wend
            ldaa freq+1
            adda #10
            staa freq+1 
            ldaa freq
            adca #0
            staa freq
            ldx freq
            cpx #200
        while ne | wend
        jsr $f06c
    pulb | pula
rts


; void Sound_Hit();
cseg
Sound_Hit:
    ldx #300
    stx freq
    do 
        jsr $f036
        ldx #1500
        do 
            dex
        while ne | wend
        ldaa freq+1
        suba #10
        staa freq+1 
        ldaa freq
        sbca #0
        staa freq
        ldx freq
        cpx #100
    while ne | wend
    jsr $f06c
rts

Sound_Hit_: public Sound_Hit_
    ldx #Sound_Hit
    stx SoundProc_
rts


; void Sound_Loose();
Sound_Loose:
    ldx #200
    stx freq
    do 
        jsr $f036
        ldx #1500
        do 
            dex
        while ne | wend
        ldaa freq+1
        adda #10
        staa freq+1 
        ldaa freq
        adca #0
        staa freq
        ldx freq
        cpx #700
    while ne | wend
    jsr $f06c
rts

Sound_Loose_: public Sound_Loose_
    ldx #Sound_Loose
    stx SoundProc_
rts


MelodyWait:
    stx APtr
    ldaa #1
    staa ALen

;    ldaa #10
;    staa $2c

    ldaa #TimerBValue
    staa TimerB

    do
        ldaa APtr
        oraa APtr+1
    while ne | wend
rts

C2 equ 1
C2S equ 2
D2 equ 3
D2S equ 4
E2 equ 5
F2 equ 6
F2S equ 7
G2 equ 8
G2S equ 9
A2 equ 10
A2S equ 11
B2 equ 12
C3 equ 13
C3S equ 14
D3 equ 15
D3S equ 16
E3 equ 17
F3 equ 18
F3S equ 19
G3 equ 20
G3S equ 21
A3 equ 22
A3S equ 23
B3 equ 24
C4 equ 25
C4S equ 26
D4 equ 27
D4S equ 28
E4 equ 29
F4 equ 30
F4S equ 31
G4 equ 32
G4S equ 33
A4 equ 34
A4S equ 35
B4 equ 36
C5 equ 37
C5S equ 38
D5 equ 39
D5S equ 40
E5 equ 41
F5 equ 42
G5 equ 44


; void Sound_Beep();
up_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Up: public Sound_Up
    psha | pshb
        ldx #up_notes
        bsr MelodyWait
    pulb | pula
rts
Sound_Up_: public Sound_Up_
    ldx #Sound_Up
    stx SoundProc_
rts


; void Sound_Start();
start_notes:
	defb 5,A4,1,0, 11,B4,1,0, 11,C5,1,0
	defb 11,C5,1,0, 5,A4,1,0, 11,D5,1,0
	defb 11,D5,1,0, 5,C5,1,0, 17,D5,1,0
	defb 35,E5,1,0
	defb 12,0
    defb 0
Sound_Start_: public Sound_Start_
    ldx #start_notes
    bsr MelodyWait
rts


; ; void Sound_Clear();
; clear_notes: 
; 	defb 5,A4,1,0, 6,0, 5,A4,1,0, 5,G4,1,0
; 	defb 5,A4,1,0, 11,C5,1,0, 5,D5,1,0
; 	defb 6,0, 5,C5,1,0, 6,0, 17,A4,1,0
; 	defb 24,0
;     defb 0
; Sound_Clear_: public Sound_Clear_
;     ldx #clear_notes
;     bsr MelodyWait
; rts


; void Sound_GameOver();
over_notes: 
	defb 11,A4,1,0, 5,E4,1,0, 5,A4,1,0
	defb 5,G4,1,0, 5,F4,1,0, 5,E4,1,0, 5,D4,1,0
	defb 35,E4,1,0
	defb 12,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    ldx #over_notes
    bsr MelodyWait
rts

BGM_B: 
	defb 17,A4,1,0, 17,B4,1,0
	defb 23,C5,1,0
	defb 11,C5,1,0, 11,B4,1,0
	defb 11,C5,1,0, 17,B4,1,0
	defb 17,G4,1,0, 35,G4,1,0
	defb 24,0
	defb 17,A4,1,0, 17,B4,1,0
	defb 23,C5,1,0
	defb 11,C5,1,0, 11,B4,1,0
	defb 11,C5,1,0, 17,G5,1,0
	defb 17,D5,1,0, 35,D5,1,0
	defb 24,0
	defb 17,F5,1,0, 17,E5,1,0
	defb 23,F5,1,0
	defb 11,F5,1,0, 11,E5,1,0
	defb 11,F5,1,0, 17,E5,1,0
	defb 17,C5,1,0, 35,C5,1,0
	defb 24,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 11,C5,1,0
	defb 11,C5,1,0, 5,C5,1,0, 5,B4,1,0
	defb 5,B4,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,D5,1,0, 5,D5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 11,E5,1,0
	defb 11,E5,1,0, 5,E5,1,0, 5,F5,1,0
	defb 11,F5,1,0, 17,E5,1,0
	defb 12,0
    defb 0
BGM_C: 
	defb 11,A2,1,0, 6,0, 5,A2,1,0
	defb 6,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 11,D3,1,0, 6,0, 5,D3,1,0
	defb 6,0, 5,D3,1,0, 6,0, 5,D3,1,0
	defb 11,E2,1,0, 6,0, 5,E2,1,0
	defb 6,0, 5,E2,1,0, 6,0, 5,E2,1,0
	defb 11,A2,1,0, 6,0, 5,A2,1,0
	defb 6,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 11,A2,1,0, 6,0, 5,A2,1,0
	defb 6,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 11,F2,1,0, 6,0, 5,F2,1,0
	defb 6,0, 5,F2,1,0, 6,0, 5,F2,1,0
	defb 11,G2,1,0, 6,0, 5,G2,1,0
	defb 6,0, 5,G2,1,0, 6,0, 5,G2,1,0
	defb 11,E2,1,0, 6,0, 5,E2,1,0
	defb 6,0, 5,E2,1,0, 6,0, 5,E2,1,0
	defb 11,D3,1,0, 6,0, 5,D3,1,0
	defb 6,0, 5,D3,1,0, 6,0, 5,D3,1,0
	defb 11,G2,1,0, 6,0, 5,G2,1,0
	defb 6,0, 5,G2,1,0, 6,0, 5,G2,1,0
	defb 11,C3,1,0, 6,0, 5,C3,1,0
	defb 6,0, 5,C3,1,0, 6,0, 5,C3,1,0
	defb 11,C3,1,0, 6,0, 5,C3,1,0
	defb 6,0, 5,C3,1,0, 6,0, 5,C3,1,0
	defb 5,A2,1,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 6,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 5,D3,1,0, 5,D3,1,0, 6,0, 5,D3,1,0
	defb 6,0, 5,D3,1,0, 6,0, 5,D3,1,0
	defb 5,A2,1,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 6,0, 5,A2,1,0, 6,0, 5,A2,1,0
	defb 5,F2,1,0, 5,F2,1,0, 6,0, 17,E2,1,0
	defb 12,0
    defb 0

; void StartBGM();
StartBGM_: public StartBGM_
    psha
        ldx #BGM_B
        stx BPtr
        ldx #BGM_C
        stx CPtr
        ldaa #1
        staa BLen
        staa CLen
        ldaa #TimerBValue
        staa TimerB
    pula
rts


; void ContineBGM();
ContineBGM_: public ContineBGM_
    ldaa BPtr
    oraa BPtr+1
    if eq
        ldaa CPtr
        oraa CPtr+1
        if eq
            bra StartBGM_
        endif
    endif
rts


; void StopBGM();
StopBGM_: public StopBGM_
    clr TimerB
    ldx #0
    stx BPtr
    stx CPtr
    clr $c812
    clr $c814
rts
