#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

static const byte[] ColorSource = {
    Char_Star, 1, 0x47,
    Char_FighterBullet, 1, 0x47,
    Char_EnemyBullet, 1, 0x46,
    Char_Fighter, 4, 0x47,
    Char_Bang, 4, 0x42,
    Char_Item, 4, 0x44,
    Char_FixedEnemyA, 4, 0x43,
    Char_FixedEnemyB, 4, 0x42,
    Char_FixedEnemyC, 4, 0x46,
    0xff
};

byte[256] CharColors;

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}

void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x07;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
    SetPattern(Char_Star, Pattern_Star, Pattern_Enemy - Pattern_Star);
    SetPattern(Char_FixedEnemyA, Pattern_EnemyA, 4);
    SetPattern(Char_FixedEnemyB, Pattern_EnemyB, 4);
    SetPattern(Char_FixedEnemyC, Pattern_EnemyC, 4);
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, Char_Space);
    FillMemory(Attr, VramWidth * VramHeight, 0x07);
}


ptr<byte> Put2C(ptr<byte> pVram, byte c, byte color)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c, color);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}


ptr<byte> Erase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, Char_Space, 0x07);
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}
